﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;


namespace erettsegi03_telefonszamla
{
        
        struct THívás
        {
            public DateTime kezd;
            public DateTime vég;
            public string telszám;
            public TimeSpan hívásideje;
        }

    class erettsegi03_telefonszamla
    {
        static void Main()
        {
            #region 1. feladat: Telefonszám bekérése, elemzése
            Console.WriteLine("1. Feladat: Kérek egy telefonszámot:");
            string[] mobilszámok = { "39", "41", "71"};
            string szám=Console.ReadLine(); //szám bekérése
            if (szám.Length > 3)
                Console.WriteLine(mobilszámok.Contains(szám.Substring(0, 2)) ?
                    "A bevitt szám mobilszám!" : "A bevitt szám nem mobilszám!");
            #endregion

            #region 2. feladat: Eltelt idő meghatározása
            
            Console.WriteLine("\n2. Feladat: eltelt idő meghatározása:");
            Console.WriteLine("Kérem a hívás kezdetét! (ó:p:mp formában)");
            DateTime kezd = DateTime.Parse(Console.ReadLine());
            
            Console.WriteLine("Kérem a hívás végét! (ó:p:mp formában)");
            DateTime vég = DateTime.Parse(Console.ReadLine());
            TimeSpan hívás_ideje = vég - kezd;
            Console.WriteLine("Számlázott percek: {0}", Math.Ceiling(hívás_ideje.TotalMinutes));
            #endregion

            #region 3. feladat: hivasok.txt file feldolgozása, percek.txt kiírása
            Console.WriteLine("\n3. Feladat: A hivasok.txt file feldolgozása, percek.txt kiírása");

            List <THívás> t = new List <THívás> ();
            using (StreamReader sr = new StreamReader("hivasok.txt"))
            {
                while (!sr.EndOfStream)
                {
                    string s = sr.ReadLine();
                    string[] fields = s.Split(' '); // adatok feldarabolása
                    THívás Segéd;
                    Segéd.kezd = DateTime.Parse(fields[0] + ':' + fields[1] + ':' + fields[2]);
                    Segéd.vég = DateTime.Parse(fields[3] + ':' + fields[4] + ':' + fields[5]);
                    Segéd.telszám = sr.ReadLine(); //telefonszám beolvasása
                    Segéd.hívásideje = Segéd.vég - Segéd.kezd;
                    t.Add(Segéd);
                }
            }

            //File kiírása
            using (StreamWriter sw = new StreamWriter("percek.txt"))
            {
                foreach (THívás h in t)
                    sw.WriteLine("{0} {1}", Math.Ceiling(h.hívásideje.TotalMinutes), h.telszám); //kiírás
            }
            #endregion

            #region 4. feladat: Hívasok száma csúcsidőben, ill. azon kívül
            Console.WriteLine("\n4. Feladat: Hívasok száma csúcsidőben, ill. azon kívül");
            int hdbcsúcsidő=0; //hívások száma csúcsidőbe
            foreach (THívás h in t)
                if (h.kezd > DateTime.Parse("7:0:0") && h.kezd <= DateTime.Parse("18:0:0")) hdbcsúcsidő++;
            Console.WriteLine("Csúcsidőben {0} db, csúcsidőn kívül: {1} db hívás volt!", hdbcsúcsidő, t.Count-hdbcsúcsidő);
            #endregion

            #region 5. feladat: Mobil és vezetékes hívások percei
            Console.WriteLine("\n5. Feladat: Mobil és vezetékes hívások percei");
            int mobilpercek=0;
            int vezetékespercek=0;
            foreach (THívás h in t)
                if (mobilszámok.Contains(h.telszám.Substring(0, 2))) mobilpercek+=(int)Math.Ceiling(h.hívásideje.TotalMinutes);
                    else vezetékespercek += (int)Math.Ceiling(h.hívásideje.TotalMinutes);
            Console.WriteLine("Mobil hívások össz. {0} perc, vezetéske hívások {1} perc.",mobilpercek, vezetékespercek);
            #endregion

            #region 6. feladat: Csúcsidős hívások díja
            Console.WriteLine("\n6. Feladat: Csúcsidős hívások díjai");

            double összeg = 0; //csúcsidős hívások összege itt lesz tárolva
            foreach (THívás h in t)
            {
                if (h.kezd > DateTime.Parse("7:0:0") && h.kezd <= DateTime.Parse("18:0:0"))
                {
                    összeg += mobilszámok.Contains(h.telszám.Substring(0, 2)) ?
                        Math.Ceiling(h.hívásideje.TotalMinutes) * 69.175 : Math.Ceiling(h.hívásideje.TotalMinutes) * 30;
                }
            }
            Console.WriteLine("Fizetendő összeg a csúcsidős hívásokért: {0} Ft.", összeg);
            #endregion

            Console.ReadKey();
        }
    }
}